﻿Imports System
Imports System.IO.Ports

Public Class DCG
    Delegate Sub TextBoxCallback(ByVal text As String)
    Dim input As String         ' In dieser Variable werden die empfangenen Daten gespeichert
    Dim com_check As Boolean    ' Wird gesetzt, wenn COM geöffnet wird
    Dim refresh_check As Boolean ' Wird gesetzt, wenn Refresh an ist
    Dim answer_check As Boolean ' Wird bei jeder Ausgabe gesetzt und beim Empfang gelöscht
    Dim argument_check As Integer   ' Wird verwendet um Abfrage und Empfang auf Übereinstimmung zu überprüfen
    Dim request_number As Integer ' Welche Abfrage läuft gerade
    Dim U_werte As New ArrayList   ' Hier werden die U-Ist-Werte nach jeder Abfrage gespeichert
    Dim I_werte As New ArrayList    ' Hier werden die I-Ist-Werte nach jeder Abfrage gespeichert
    Dim time_werte As New ArrayList ' zu jedem U bzw. I-Ist-Wert muss auch die vergangene Zeit ermittelt werden
    Dim time_elapsed As Integer     ' Erhöht sich bei jedem Timeraufruf um ein Timerintervall


    Private Sub DCG_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AddHandler SerialPort.DataReceived, AddressOf DataReceviedHandler
        com_check = False       ' Beim Start ist COM Port geschlossen
        refresh_check = True     ' Standarmäßig ist Refresh an
        answer_check = False    ' Es wurde noch keine Abfrage gesendet
        U_werte.Add(0)          ' Erster Wert der Ausgangsspannung soll 0 betragen
        I_werte.Add(0)          ' Erster Wert des Ausgangsstroms soll 0 betragen
        time_werte.Add(0)       ' Zum dazugehörigen Zeitpunkt 0
    End Sub


    Private Sub COMPortToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles COMPortToolStripMenuItem.Click
        COM.Show()
    End Sub


    Private Sub BaudrateToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BaudrateToolStripMenuItem.Click
        Baudrate.Show()
    End Sub



    Private Sub Verbinden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles connect_button.Click
        Try
            If (com_check = False) Then ' Prüfen ob Com Port offen ist, wenn nein öffnen
                SerialPort.Open()
                If refresh_check = True Then    ' Prüfen ob refresh an oder aus ist
                    Timer.Start()               ' Falls Refresh an: Timer starten
                End If
                com_check = True                ' Com Port ist nun offen => speichern
                connect_button.Text = "Trennen" ' Buttontext ändern

            ElseIf (com_check = True) Then  ' Wenn ja schließen
                Timer.Stop()                ' Timer stoppen
                SerialPort.Close()          ' Serialport schließen
                com_check = False           ' Com Port ist nun geschlossen => speichern
                connect_button.Text = "Verbinden"   ' Buttonntext ändern
            End If
        Catch
            MsgBox("Port nicht verfügbar oder wird gerade verwendet") ' Falls etwas schief geht: Fehlermeldung
            connect_button.Text = "Verbinden"                       ' Buttontext ändern
        End Try
    End Sub


    Private Sub DataReceviedHandler(ByVal sender As Object, ByVal e As SerialDataReceivedEventArgs)
        Dim sp As SerialPort = CType(sender, SerialPort)
        Dim indata As String = sp.ReadExisting()    ' Empfangene Daten abfragen
        Me.ShowText(indata)
    End Sub

    Private Sub ShowText(ByVal text As String)
        If Me.U_Soll.InvokeRequired Then        ' Wert kann nicht einfach auf anderen Thread übertragen werden => invoke

            Dim d As New TextBoxCallback(AddressOf ShowText)
            Me.Invoke(d, New Object() {text})
        Else                                    ' Falls kein Invoke nötig weiter

            input = input + text
            ' Überprüfen ob die Eingabe ein !  enthält, falls ja lösche Eingang
            If input.Contains("!") Then
                input = ""          ' input löschen
            End If

            ' Sobald CR und LF Empfangen wurde ist der Empfang eines Kommandos abgeschlossen => Auswertung
            If input.EndsWith(ControlChars.CrLf) Then
                input_auswerten(input) ' Auswerten
                input = "" ' Eingang kann nun gelöscht werden
            End If

        End If
    End Sub

    Private Sub input_auswerten(ByVal input)

        ' input zerlegen
        Dim value_input As String
        Dim sArray As String() ' Gesplitteten Dateien werden im Array gespeichert
        sArray = Split(input, "=") ' String wird ab "=" geteilt

        ' Argument aus der empfangenen Zeichenkette ermitteln
        Dim subch_input As String
        Dim sArray2 As String()
        subch_input = sArray(0) ' Argument muss sich vor dem "=" befinden
        ' Modulnummer und Doppelpunkt entfernen
        sArray2 = Split(subch_input, ":")

        ' Nur wenn der auch der SubCH Empfangen wurde, kann weiter ausgewertet werden
        If (sArray2.Length > 1) Then
            subch_input = sArray2(1)    ' SubCh befindet sich im Array mit dem Index 1

            ' Wert zum zugehörigen Argument ermitteln
            value_input = sArray(1)     ' Arraywert mit dem Index 1 auf Variable übertragen
            value_input = value_input.Replace(ControlChars.CrLf, "") ' CR und LF entfernen
            'U_Soll.Text = U_Soll.Text & value_input
            ausgeben(subch_input, value_input)      ' Funktion ausgeben aufrufen, SubCH und den dazugehörigen Wert übergeben

            ' Ist es die Richtige Antwort auf die Anfrage
            If (subch_input = argument_check) Then
                answer_check = False ' Wenn ja die Anfrage mit Nummer x ist abgeschlossen
            End If

            If (subch_input < 233) Then ' sobald subch = 233 sind alle Werte ausgelesen
                auslesen()              ' Nur wenn subCh kleiner 233 muss die auslesen Funktion aufgerufen werden
                request_number += 1     ' Request Nummer um eins erhöhen
            Else
                U_Graph.CreateGraph(U_Graph.ZedGraphControl1, U_werte, time_werte)
            End If

            ' Input löschen für neuen Datenempfang
            input = ""

        End If
    End Sub

    ' Hier werden die Abfragen für die verschieden Strom und Spannungswert etc. abgeschickt
    Private Sub auslesen()

        If (answer_check = False And request_number = 0) Then
            SerialPort.WriteLine("DCV?" + vbCrLf)   ' U-Soll abfragen
            answer_check = True
            argument_check = 0
        End If

        If answer_check = False And request_number = 1 Then
            SerialPort.WriteLine("DCA?" + vbCrLf)   ' I-Soll abfragen
            answer_check = True
            argument_check = 1
        End If

        If answer_check = False And request_number = 2 Then
            SerialPort.WriteLine("MAH?" + vbCrLf)   ' charge abfragen
            answer_check = True
            argument_check = 7
        End If

        If answer_check = False And request_number = 3 Then
            SerialPort.WriteLine("MWH" + vbCrLf)   ' energy abfragen
            answer_check = True
            argument_check = 8
        End If

        If answer_check = False And request_number = 4 Then
            SerialPort.WriteLine("MSV?" + vbCrLf)   ' U-Ist abfragen
            answer_check = True
            argument_check = 10
        End If

        If answer_check = False And request_number = 5 Then
            SerialPort.WriteLine("MSA?" + vbCrLf)   ' I-Ist abfragen
            answer_check = True
            argument_check = 11
        End If

        If answer_check = False And request_number = 6 Then
            SerialPort.WriteLine("MSA?" + vbCrLf)   ' I-Ist abfragen
            answer_check = True
            argument_check = 11
        End If

        If answer_check = False And request_number = 7 Then
            SerialPort.WriteLine("MSW?" + vbCrLf)   ' Leistung abfragen
            answer_check = True
            argument_check = 18
        End If

        If answer_check = False And request_number = 8 Then
            SerialPort.WriteLine("TMP?" + vbCrLf)   ' Temperatur abfragen
            answer_check = True
            argument_check = 233
            request_number = 0
        End If
    End Sub

    ' Hier werden die Werte in die dazugehörigen Textfelder geschrieben
    Private Sub ausgeben(ByVal subch, ByVal value)
        Select Case subch
            Case 0
                U_Soll.Text = value
            Case 1
                I_Soll.Text = value
            Case 7
                charge.Text = value
            Case 8
                energy.Text = value
            Case 10
                U_Ist.Text = value
                value = value / 10000   ' Umrechnung damit die Werte richtig im Diagramm erscheinen
                U_werte.Add(value)      ' Speichert den Spannungs-Ist-Wert in eine Arraylist
            Case 11
                I_Ist.Text = value
                I_werte.Add(value)      ' Speichert den Strom-Ist-Wert in eine Arraylist
            Case 18
                power.Text = value
            Case 233
                temperature.Text = value
        End Select
    End Sub

    Private Sub RefreshToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RefreshToolStripMenuItem.Click
        refresh_time.Show()
    End Sub

    ' Sobald der Timer aktiv wird, soll eine neu Abfrage (alle Werte) gestartet werden
    Private Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer.Tick
        Try
            auslesen()
        Catch ex As Exception
            MsgBox("Keine Verbindung zum DCG Modul")
        End Try
        time_elapsed += Timer.Interval / 1000 ' Jedesmal wenn Timer_Tick aufgerufen wird, erhöht sich time_elapsed um ein Timerintervall
        time_werte.Add(time_elapsed.ToString) ' Timer Intervalle in Arraylist speichern

    End Sub

    ' Bereich für die manuelle Abfrage, falls Refresh ausgeschaltet ist
    Private Sub receive_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles receive_button.Click
        auslesen()
    End Sub

    ' Refresh Button 
    Private Sub Refresh_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles refresh_button.Click
        If refresh_check = False Then
            refresh_button.Text = "stop refresh"
            refresh_check = True
            receive_button.Enabled = False
            Timer.Start()
        ElseIf refresh_check = True Then
            refresh_button.Text = "start refresh"
            refresh_check = False
            receive_button.Enabled = True
            Timer.Stop()
        End If
    End Sub

    Private Sub ToolStripButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton2.Click
        Info.Show()
    End Sub

    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub send_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles send_button.Click
        SerialPort.WriteLine("DCV=" + U_Soll.Text + vbCrLf)
        'System.Threading.Thread.Sleep(500)
        SerialPort.WriteLine("DCA=" + I_Soll.Text + vbCrLf)
    End Sub


    Private Sub U_Verlauf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles U_Verlauf.Click
        U_Graph.Show()
    End Sub
End Class


